<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/**
 * Smarty close_tags modifier plugin
 *
 * Type:     modifier<br>
 * Name:     close_tags<br>
 * Purpose:  close dangling tags
 * @author   Vadim Arasev <varasev at gmail dot com>
 * @param string
 * @return string
 */
function smarty_modifier_close_tags($html)
{
	#put all opened tags into an array
	preg_match_all("#<([a-z]+)( .*)?(?!/)>#iU", $html, $result);
	$openedtags = $result[1];
	
	#put all closed tags into an array
	preg_match_all("#</([a-z]+)>#iU", $html, $result);
	$closedtags = $result[1];
	$len_opened = count($openedtags);
	
	# all tags are closed
	if (count($closedtags) == $len_opened) {
		return $html;
	}
	
	$openedtags = array_reverse($openedtags);
	
	# close tags
	$unpair_tags = array('br', 'frame', 'hr', 'img', 'input', 'param');
	
	for ($i = 0; $i < $len_opened; ++$i) {
		if (!in_array($openedtags[$i], $closedtags)) {
			if (!in_array($openedtags[$i], $unpair_tags)) {
				$html .= '</'.$openedtags[$i].'>';
			}
		} else {
			unset($closedtags[array_search($openedtags[$i],$closedtags)]);
		}
	}
	return $html;
}

/* vim: set expandtab: */

?>
