<?php
/*****************************************************************************\
+-----------------------------------------------------------------------------+
| Fast-Sales Pro                                                              |
| Copyright (c) 2007-2009 Fsales development group <support@fast-sales.ru>    |
| All rights reserved.                                                        |
+-----------------------------------------------------------------------------+
| PLEASE READ  THE FULL TEXT OF SOFTWARE LICENSE AGREEMENT IN THE "COPYRIGHT" |
| FILE PROVIDED WITH THIS DISTRIBUTION. THE AGREEMENT TEXT IS ALSO AVAILABLE  |
| AT THE FOLLOWING URL: http://fast-sales.ru/fsales_pro_license.html          |
|                                                                             |
| THIS  AGREEMENT  EXPRESSES  THE  TERMS  AND CONDITIONS ON WHICH YOU MAY USE |
| THIS SOFTWARE   PROGRAM   AND  ASSOCIATED  DOCUMENTATION   THAT  Fsales     |
| development group (hereinafter  referred to as "THE AUTHOR") IS FURNISHING  |
| OR MAKING AVAILABLE TO YOU WITH  THIS  AGREEMENT  (COLLECTIVELY,  THE       |
| "SOFTWARE"). PLEASE   REVIEW   THE  TERMS  AND   CONDITIONS  OF  THIS       |
| LICENSE AGREEMENT CAREFULLY   BEFORE   INSTALLING   OR  USING  THE          |
| SOFTWARE.  BY INSTALLING, COPYING   OR   OTHERWISE   USING   THE            |
| SOFTWARE,  YOU  AND  YOUR  COMPANY (COLLECTIVELY,  "YOU")  ARE  ACCEPTING   |
| AND AGREEING  TO  THE TERMS OF THIS LICENSE   AGREEMENT.   IF  YOU    ARE   |
| NOT  WILLING   TO  BE  BOUND BY THIS AGREEMENT, DO  NOT INSTALL OR USE THE  |
| SOFTWARE.  VARIOUS   COPYRIGHTS   AND OTHER   INTELLECTUAL   PROPERTY       |
| RIGHTS    PROTECT   THE   SOFTWARE.  THIS AGREEMENT IS A LICENSE AGREEMENT  |
| THAT GIVES  YOU  LIMITED  RIGHTS   TO  USE THE  SOFTWARE   AND  NOT  AN     |
| AGREEMENT  FOR SALE OR FOR  TRANSFER OF TITLE. THE AUTHOR RETAINS ALL RIGHTS|
| NOT EXPRESSLY GRANTED BY THIS AGREEMENT.                                    |
|                                                                             |
| The Initial Developers of the Original Code are Fsales development group    |
| Portions created by Fsales development group are Copyright (C) 2007-2009    |
| Fsales development group. All Rights Reserved.                              |
+-----------------------------------------------------------------------------+
\*****************************************************************************/

	require 'setup.php';
	
	if (isset($_SESSION['installed']) && $_SESSION['installed']) {
		exit;
	}
	
	if ($_REQUEST['what'] == 'rights') {
		// Устанавливаем права на запись на некоторые директории и файлы
		
		function set_htaccess() {
			$lines = file(ROOT_DIR.'.htaccess', FILE_IGNORE_NEW_LINES);
			
			foreach ($lines as $k => $line) {
				if (strpos($line, 'RewriteBase') !== false) {
					$base_url_info = parse_url(BASE_URL);
					$lines[$k] = 'RewriteBase '.$base_url_info['path'];
				} elseif (strpos($line, 'RewriteRule') !== false && strpos($line, 'http://') !== false && strpos($line, 'R=301') !== false) {
					$base_url_info = parse_url(BASE_URL);
					$lines[$k] = 'RewriteRule ^(.*)$ http://%1'.$base_url_info['path'].'$1 [R=301,L]';
				} elseif (strpos($line, 'RewriteRule') !== false && strpos($line, '^index.(html|htm)$') !== false && strpos($line, 'R=301') !== false) {
					$base_url_info = parse_url(BASE_URL);
					$lines[$k] = 'RewriteRule ^index.(html|htm)$ '.$base_url_info['path'].' [R=301,L]';
				} elseif (strpos($line, 'ErrorDocument 404') !== false) {
					$base_url_info = parse_url(BASE_URL);
					$lines[$k] = 'ErrorDocument 404 '.$base_url_info['path'].'index.php?error404';
				}
			}
			
			file_put_contents(ROOT_DIR.'.htaccess', join("\n", $lines));
		}
		
		function set_defs() {
			$mysqlserver = $_SESSION['install_data']['mysqlserver'];
			$mysqldbname = $_SESSION['install_data']['mysqldbname'];
			$mysqllogin  = $_SESSION['install_data']['mysqllogin'];
			$mysqlpwd    = $_SESSION['install_data']['mysqlpwd'];
			
			$lines = file(ROOT_DIR.'includes/defs.php', FILE_IGNORE_NEW_LINES);
			
			foreach ($lines as $k => $line) {
				if (strpos($line, '\'DB_HOST\'') !== false) {
					$lines[$k] = sprintf("\t".'define(\'DB_HOST\', \'%s\');', $mysqlserver);
				} elseif (strpos($line, '\'DB_NAME\'') !== false) {
					$lines[$k] = sprintf("\t".'define(\'DB_NAME\', \'%s\');', $mysqldbname);
				} elseif (strpos($line, '\'DB_USER\'') !== false) {
					$lines[$k] = sprintf("\t".'define(\'DB_USER\', \'%s\');', $mysqllogin);
				} elseif (strpos($line, '\'DB_PASS\'') !== false) {
					$lines[$k] = sprintf("\t".'define(\'DB_PASS\', \'%s\');', $mysqlpwd);
				} elseif (strpos($line, '\'BASE_URL_REW\'') !== false) {
					$base_url_info = parse_url(BASE_URL);
					$lines[$k] = sprintf("\t".'define(\'BASE_URL_REW\', \'%s\'); // должен обязательно начинаться и оканчиваться на /', $base_url_info['path']);
				}
			}
			
			file_put_contents(ROOT_DIR.'includes/defs.php', join("\n", $lines));
		}
		
		function set_fancy_css() {
			$path  = ROOT_DIR.'includes/libs/jquery/plugins/fancybox/css/styles.css';
			$lines = file($path, FILE_IGNORE_NEW_LINES);
			
			$base_url_info = parse_url(BASE_URL);
			
			foreach ($lines as $k => $line) {
				$lines[$k] = str_replace("AlphaImageLoader(src='/includes", "AlphaImageLoader(src='".$base_url_info['path']."includes", $line);
			}
			
			file_put_contents($path, join("\n", $lines));
		}
		
		function set_file_settings($file) {
			if ($file == '.htaccess') { // Прописываем RewriteBase в htaccess
				set_htaccess();
			} elseif ($file == 'includes/defs.php') { // Прописываем настройки в defs.php
				set_defs();
			} elseif ($file == 'includes/libs/jquery/plugins/fancybox/css/styles.css') { // Прописываем путь в fancy css
				set_fancy_css();
			}
		}
		
		require 'dirs.php'; // Подключаем массив путей к директориям
	
		foreach ($dirs as $k => $dir) {
			if (!is_writable(ROOT_DIR.$dir)) {
				if (chmod(ROOT_DIR.$dir, 0777)) {
					unset($dirs[$k]);
				}
			} else {
				unset($dirs[$k]);
			}
		}
		
		// Сейчас в $dirs находится список директорий, для которых нужно установить права для записи
		
		require 'files.php'; // Подключаем массив путей к файлам
		
		foreach ($files as $k => $file) {
			if (is_writable(ROOT_DIR.$file)) {
				set_file_settings($file);
				unset($files[$k]);
			} else {
				$oldmod = fileperms(ROOT_DIR.$file); // Запоминаем старые атрибуты доступа
				
				if (chmod(ROOT_DIR.$file, 0777)) {
					set_file_settings($file);
					
					unset($files[$k]);
					
					chmod(ROOT_DIR.$file, $oldmod);
				}
			}
		}
		
		// Сейчас в $files находится список файлов, для которых нужно установить права для записи
		
		if (intval($_SESSION['install_data']['need_ftp']) && (!empty($dirs) || !empty($files))) { // Пытаемся установить права с помощью FTP
			$ftpserver   = $_SESSION['install_data']['ftpserver'];
			$ftplogin    = $_SESSION['install_data']['ftplogin'];
			$ftppwd      = $_SESSION['install_data']['ftppwd'];
			
			require ROOT_DIR.'includes/libs/ftp/ftp_class.php';
			
			$ftp = new ftp;
			
			// Определяем директорию магазина на FTP
			$ftp->SetTimeout(10);
		
			if (!$ftp->SetServer($ftpserver)) {
				$err[] = 'Не удается обратиться к FTP-серверу по указанному адресу';
			} else {
				if (!$ftp->connect()) {
					$err[] = 'Не удается подключиться к FTP-серверу по указанному адресу';
				} else {
					if (!$ftp->login($ftplogin, $ftppwd)) {
						$err[] = 'Неверно указан логин и/или пароль к FTP';
					} else {
						// Определяем директорию магазина на сервере
						if (strpos(dirname(__FILE__), '/') !== false) {
							$dirsep = '/';
						} else {
							$dirsep = '\\';
						}
						
						$paths = explode($dirsep, dirname(__FILE__));
						
						$success = false;
						
						$shopdir = '';
						
						for ($i = count($paths) - 1; $i >= 0; --$i) {
							$shopdir = $paths[$i].'/'.$shopdir;
							
							if ($ftp->is_exists($shopdir.basename(__FILE__))) {
								$success  = true;
								$shopdir  = trim(dirname(rtrim($shopdir, '\\/')), '\\/');
								$shopdir .= '/';
								break;
							}
						}
						
						if (!$success) {
							$err[] = 'Не удается найти директорию магазина на указанном FTP';
						} else {
							// $shopdir - директория магазина на FTP
							
							if (is_array($dirs)) {
								foreach ($dirs as $k => $dir) {
									if ($ftp->chmod($shopdir.$dir, 0777)) {
										unset($dirs[$k]);
									}
								}
								
								// В $dirs содержится список директорий, для которых не удалось установить права
							}
							
							// Пробуем редактировать файлы с настройками
							foreach ($files as $k => $file) {
								$oldmod = fileperms(ROOT_DIR.$file); // Запоминаем старые атрибуты доступа
								
								if ($ftp->chmod($shopdir.$file, 0777)) { // Делаем файл перезаписываемым
									set_file_settings($file);
									
									if (!$ftp->chmod($shopdir.$file, $oldmod)) { // Восстанавливаем прежние атрибуты доступа
										$err[] = 'Не удалось отредактировать файл '.$file;
									} else {
										unset($files[$k]);
									}
								} else {
									$err[] = 'Не удалось отредактировать файл '.$file;
								}
							}
						}
					}
					$ftp->quit();
				}
			}
		}
		
		if (is_array($dirs)) {
			$dirs = join('<br />', $dirs);
		}
		
		if (func_count_array($files) > 0) {
			$err[] = 'Не удается прописать настройки в необходимые файлы. Обратитесь в службу поддержки, либо зайдите на сервер через SSH и запустите install/install.sh, после чего перезапустите установку.';
		}
		
		echo func_to_json($dirs, '', $err);
	} elseif ($_REQUEST['what'] == 'db') {
		// Устанавливаем базу данных
		
		$begin_pos = isset($_REQUEST['begin_pos']) ? $_REQUEST['begin_pos'] : 0;
		
		define('FS_ONLY_TABLES',    true);
		define('CURRENT_TIMESTAMP', isset($_SERVER['REQUEST_TIME']) ? $_SERVER['REQUEST_TIME'] : time());
		
		require ROOT_DIR.'includes/defs.php';
		require ROOT_DIR.'includes/config.php';
		
		$DB = new DB();
		
		$max_execution_time = ini_get('max_execution_time');
		
		if ($max_execution_time <= 0) {
			$max_execution_time = 20;
		}
		
		$sql_text = file_get_contents('db.sql');
		
		$sqls = explode(";-- EOL\n", $sql_text);
		$sqls_count = count($sqls);
		
		for ($i = $begin_pos; $i < $sqls_count; ++$i) {
			$sql = trim($sqls[$i]);
			
			if (!empty($sql)) {
				if (!$DB->Query($sql)) {
					$err[] = 'Не удается установить базу данных';
					break;
				}
			}
			
			$begin_pos = $i + 1;
			
			if (time() - CURRENT_TIMESTAMP >= $max_execution_time / 2) {
				break;
			}
		}
		
		if ($begin_pos >= $sqls_count) {
			$progress = '';
			
			// Изменение e-mail адресов уведомлений в настройках на адрес созданного админа
			$DB->Query('UPDATE '.$TABLES['settings'].' SET `value` = "'.$_SESSION['install_data']['adminemail'].'" WHERE `name` IN ("admin_email", "orders_notify_email", "other_notify_email")');
			
			// Очистка лога ошибок
			fn_del_db_entity('errors');
			
			// Очистка лога посещений
			fn_del_db_entity('visitors');
			
			// Очистка заказов
			fn_del_db_entity('orders');
			
			// Перекомпилируем все шаблоны и обновляем кэш
			//$row = $DB->GetRow('SELECT `value` FROM '.$TABLES['options'].' WHERE name = "license_key" LIMIT 1');
			//fn_make_http_post_request(BASE_URL, array('clean_cache' => true, 'key' => md5($row['value'])));
		} else {
			$progress = round($begin_pos * 100 / $sqls_count).'%';
		}
		
		echo func_to_json($progress, '', $err, $begin_pos);
	} elseif ($_REQUEST['what'] == 'admin') {
		// Создаем администратора
		
		define('FS_ONLY_TABLES',    true);
		define('CURRENT_TIMESTAMP', isset($_SERVER['REQUEST_TIME']) ? $_SERVER['REQUEST_TIME'] : time());
		
		require ROOT_DIR.'includes/defs.php';
		require ROOT_DIR.'includes/config.php';
		require ROOT_DIR.'includes/classes/Users.class.php';
		
		$DB = new DB();
		
		$admin_id   = 1;
		$admin_info = array(
			'type'       => 'ADMIN',
			'email'      => $_SESSION['install_data']['adminemail'],
			'first_name' => 'Admin'
		);
		
		if (Users::Update($admin_id, $admin_info)) {
			$salt1 = Users::GenPwdSalt();
			$salt2 = Users::GenPwdSalt();
			$hash  = Users::GetPwdHash($_SESSION['install_data']['adminpwd'], $salt1, $salt2);
			
			if (Users::SetPwdHash($admin_id, $hash, $salt1, $salt2)) {
				$_SESSION['installed'] = true;
				unset($_SESSION['install_data']);
			}
		} else {
			$err[] = 'Не удается добавить администратора в магазин';
		}
		
		// Генерируем файл robots.txt
		include ROOT_DIR.'robots.php';
		
		echo func_to_json('', '', $err);
	}
	
?>